import { TreeMap } from '../treemap';
/**
 * Legend module class
 */
export declare class TreeMapLegend {
    private treemap;
    legendRenderingCollections: Object[];
    legendCollections: Object[];
    private legendHeight;
    private legendWidth;
    private totalPages;
    private page;
    private translate;
    private legendBorderRect;
    private currentPage;
    private heightIncrement;
    private widthIncrement;
    private textMaxWidth;
    legendGroup: Element;
    private legendNames;
    private defsElement;
    private gradientCount;
    private clearTimeout;
    private legendItemRect;
    constructor(treemap: TreeMap);
    renderLegend(): void;
    calculateLegendBounds(): void;
    private getPageChanged();
    private findColorMappingLegendItems(data);
    private findPaletteLegendItems(data, type);
    private calculateLegendItems(data);
    private isAddNewLegendData(legendText);
    drawLegend(): void;
    private drawLegendItem(page);
    private renderLegendBorder();
    private renderLegendTitle();
    renderInteractivePointer(e: PointerEvent | TouchEvent): void;
    private drawInteractivePointer(legend, fill, stroke, id, strokeWidth, rect);
    private getLegendAlignment(treemap, width, height, legend);
    mouseUpHandler(e: PointerEvent): void;
    removeInteractivePointer(): void;
    changeNextPage(e: PointerEvent): void;
    wireEvents(element: Element): void;
    addEventListener(): void;
    removeEventListener(): void;
    /**
     * Get module name.
     */
    protected getModuleName(): string;
    /**
     * To destroy the legend.
     * @return {void}
     * @private
     */
    destroy(treemap: TreeMap): void;
}
