var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
define(["require", "exports", "@syncfusion/ej2-base", "@syncfusion/ej2-base", "@syncfusion/ej2-base", "@syncfusion/ej2-base", "./model/base", "./model/base", "../treemap/utils/helper", "../treemap/utils/helper", "../treemap/model/constants", "../treemap/model/constants", "./layout/render-panel", "../treemap/utils/export", "@syncfusion/ej2-data"], function (require, exports, ej2_base_1, ej2_base_2, ej2_base_3, ej2_base_4, base_1, base_2, helper_1, helper_2, constants_1, constants_2, render_panel_1, export_1, ej2_data_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var TreeMap = (function (_super) {
        __extends(TreeMap, _super);
        function TreeMap(options, element) {
            var _this = _super.call(this, options, element) || this;
            _this.orientation = 'Horizontal';
            _this.drilledItems = [];
            _this.isHierarchicalData = false;
            return _this;
        }
        TreeMap.prototype.preRender = function () {
            this.trigger(constants_1.load, { treemap: this });
            this.initPrivateVariable();
            this.unWireEVents();
            this.createSvg();
            this.wireEVents();
            this.setCulture();
        };
        TreeMap.prototype.render = function () {
            this.themeEffect();
            this.createSecondaryElement();
            this.addTabIndex();
            this.renderBorder();
            this.renderTitle(this.titleSettings, 'title', null, null);
            this.processDataManager();
        };
        TreeMap.prototype.processDataManager = function () {
            var _this = this;
            var dataModule;
            var queryModule;
            var ajaxModule;
            var localAjax;
            if (this.dataSource instanceof ej2_data_1.DataManager) {
                dataModule = this.dataSource;
                queryModule = this.query instanceof ej2_data_1.Query ? this.query : new ej2_data_1.Query();
                var dataManager = dataModule.executeQuery(queryModule);
                dataManager.then(function (e) {
                    _this.dataSource = e['result'];
                    _this.renderTreeMapElements();
                });
            }
            else if (this.dataSource instanceof helper_2.TreeMapAjax) {
                localAjax = this.dataSource;
                ajaxModule = new ej2_base_1.Ajax(localAjax.dataOptions, localAjax.type, localAjax.async, localAjax.contentType);
                ajaxModule.onSuccess = function (args) {
                    _this.dataSource = JSON.parse('[' + args + ']')[0];
                    _this.renderTreeMapElements();
                };
                ajaxModule.send(localAjax.sendData);
            }
            else {
                this.renderTreeMapElements();
            }
        };
        TreeMap.prototype.renderTreeMapElements = function () {
            this.processingData();
            if (this.treeMapLegendModule && this.legendSettings.visible) {
                this.treeMapLegendModule.renderLegend();
            }
            this.layout.processLayoutPanel();
            this.element.appendChild(this.svgObject);
            this.elementChange();
            this.trigger(constants_1.loaded, { treemap: this });
        };
        TreeMap.prototype.createSvg = function () {
            if (this.svgObject) {
                while (this.svgObject.childNodes.length > 0) {
                    this.svgObject.removeChild(this.svgObject.firstChild);
                }
                if (!this.svgObject.hasChildNodes() && this.svgObject.parentNode) {
                    ej2_base_4.remove(this.svgObject);
                }
            }
            var containerWidth = this.element.clientWidth;
            var containerHeight = this.element.clientHeight;
            this.availableSize = new helper_1.Size(helper_1.stringToNumber(this.width, containerWidth) || containerWidth || 600, helper_1.stringToNumber(this.height, containerHeight) || containerHeight || 450);
            this.svgObject = this.renderer.createSvg({
                id: this.element.id + '_svg',
                width: this.availableSize.width,
                height: this.availableSize.height
            });
        };
        TreeMap.prototype.initPrivateVariable = function () {
            this.renderer = new ej2_base_4.SvgRenderer(this.element.id);
            this.layout = new render_panel_1.LayoutPanel(this);
        };
        TreeMap.prototype.themeEffect = function () {
            switch (this.theme) {
                case 'Material':
                case 'Bootstrap':
                case 'Fabric':
                    this.setTextStyle('#424242');
                    break;
                case 'Highcontrast':
                    this.setTextStyle('#FFFFFF');
                    break;
            }
        };
        TreeMap.prototype.setTextStyle = function (color) {
            this.titleSettings.textStyle.color = this.titleSettings.textStyle.color || color;
            this.titleSettings.subtitleSettings.textStyle.color = this.titleSettings.subtitleSettings.textStyle.color || color;
            this.legendSettings.textStyle.color = this.legendSettings.textStyle.color || color;
            this.legendSettings.titleStyle.color = this.legendSettings.titleStyle.color || color;
        };
        TreeMap.prototype.createSecondaryElement = function () {
            var secondaryEle = document.getElementById(this.element.id + '_Secondary_Element');
            if (secondaryEle && secondaryEle.childElementCount > 0) {
                secondaryEle.remove();
            }
            if (ej2_base_4.isNullOrUndefined(document.getElementById(this.element.id + '_Secondary_Element'))) {
                var secondaryElement = ej2_base_4.createElement('div', {
                    id: this.element.id + '_Secondary_Element',
                    styles: 'position: absolute;z-index:1;'
                });
                this.element.appendChild(secondaryElement);
            }
        };
        TreeMap.prototype.elementChange = function () {
            if (this.treeMapLegendModule && this.legendSettings.visible && this.treeMapLegendModule.legendGroup && this.layout.layoutGroup) {
                this.svgObject.insertBefore(this.layout.layoutGroup, this.treeMapLegendModule.legendGroup);
            }
        };
        TreeMap.prototype.renderBorder = function () {
            var width = this.border.width;
            var color = this.theme === 'Highcontrast' ? '#000000' : '#FFFFFF';
            this.background = this.background ? this.background : color;
            var borderElement = document.getElementById(this.element.id + '_TreeMap_Border');
            if (ej2_base_4.isNullOrUndefined(borderElement)) {
                var borderRect = new helper_1.RectOption(this.element.id + '_TreeMap_Border', this.background, this.border, 1, new helper_1.Rect(width / 2, width / 2, this.availableSize.width - width, this.availableSize.height - width));
                this.svgObject.appendChild(this.renderer.drawRectangle(borderRect));
            }
            else {
                borderElement.setAttribute('fill', this.background);
            }
        };
        TreeMap.prototype.renderTitle = function (title, type, bounds, groupEle) {
            var style = title.textStyle;
            var height;
            var titlePadding = 10;
            var width = (this.availableSize.width - this.margin.right - this.margin.left);
            if (title.text) {
                if (ej2_base_4.isNullOrUndefined(groupEle)) {
                    groupEle = this.renderer.createGroup({ id: this.element.id + '_Title_Group' });
                }
                var trimmedTitle = helper_1.textTrim(width, title.text, style);
                var elementSize = helper_1.measureText(trimmedTitle, style);
                var rect = (ej2_base_4.isNullOrUndefined(bounds)) ? new helper_1.Rect(this.margin.left, this.margin.top, this.availableSize.width, this.availableSize.height) : bounds;
                var location_1 = helper_2.findPosition(rect, title.alignment, elementSize, type);
                var options = new helper_2.TextOption(this.element.id + '_TreeMap_' + type, location_1.x, location_1.y, 'start', trimmedTitle);
                var titleBounds = new helper_1.Rect(location_1.x, location_1.y, elementSize.width, elementSize.height);
                var element = helper_2.renderTextElement(options, style, style.color, groupEle);
                element.setAttribute('aria-label', title.description || title.text);
                element.setAttribute('tabindex', (this.tabIndex + (type === 'title' ? 1 : 2)).toString());
                if ((type === 'title' && !title.subtitleSettings.text) || (type === 'subtitle')) {
                    height = (this.availableSize.height - titleBounds.y - titlePadding - this.margin.bottom);
                    this.areaRect = new helper_1.Rect(this.margin.left, titleBounds.y + titlePadding, width, height);
                }
                if (type !== 'subtitle' && title.subtitleSettings.text) {
                    this.renderTitle(title.subtitleSettings, 'subtitle', titleBounds, groupEle);
                }
                else {
                    this.svgObject.appendChild(groupEle);
                }
            }
            else {
                height = (this.availableSize.height - this.margin.top - this.margin.bottom);
                this.areaRect = new helper_1.Rect(this.margin.left, this.margin.top, width, height);
            }
        };
        TreeMap.prototype.processingData = function () {
            var _this = this;
            var path;
            this.dataSource = this.dataSource;
            if (!ej2_base_4.isNullOrUndefined(this.dataSource) && this.dataSource.length > 0 && this.weightValuePath) {
                this.levelsOfData = [];
                this.dataSource.map(function (data) {
                    data[_this.weightValuePath] = (data[_this.weightValuePath]) ? data[_this.weightValuePath].toString() :
                        data[_this.weightValuePath];
                });
                this.leafItemSettings.labelPath = this.leafItemSettings.labelPath || this.weightValuePath;
                this.checkIsHierarchicalData();
                if (this.levels.length === 0) {
                    var data_1 = new Object();
                    data_1['level'] = 0;
                    path = this.leafItemSettings.labelPath;
                    data_1[path] = [];
                    for (var i = 0; i < this.dataSource.length; i++) {
                        var child = helper_1.findChildren(this.dataSource[i])['values'];
                        if (this.isHierarchicalData && child && child.length > 0) {
                            child.forEach(function (currentData, dataIndex) {
                                if (currentData[path]) {
                                    data_1[path].push({
                                        groupIndex: 0, name: currentData[path], levelOrderName: currentData[path].toString(),
                                        data: currentData, weight: currentData[_this.weightValuePath]
                                    });
                                }
                            });
                        }
                        else {
                            if (this.dataSource[i][path]) {
                                data_1[path].push({
                                    groupIndex: 0, name: this.dataSource[i][path], levelOrderName: this.dataSource[i][path].toString(), data: this.dataSource[i],
                                    weight: this.dataSource[i][this.weightValuePath]
                                });
                            }
                        }
                    }
                    this.levelsOfData.push(data_1);
                }
                else {
                    if (this.isHierarchicalData) {
                        this.hierarchyData = [];
                        this.hierarchyData = ej2_base_1.extend([], this.dataSource, this.hierarchyData, true);
                        for (var i = 0; i < this.hierarchyData.length; i++) {
                            this.processHierarchicalData(this.hierarchyData[i], i);
                        }
                        this.levelsOfData = this.hierarchyData;
                    }
                    else {
                        this.processFlatJsonData();
                        if (this.levelsOfData.length > 1) {
                            this.reOrderLevelData(this.levelsOfData.length - 1);
                        }
                    }
                    path = this.levels[0].groupPath;
                }
                if (!this.isHierarchicalData) {
                    this.findTotalWeight(this.levelsOfData[0][path], 'Parent');
                }
            }
        };
        TreeMap.prototype.checkIsHierarchicalData = function () {
            var child;
            this.dataSource = this.dataSource;
            for (var i = 0; i < this.dataSource.length; i++) {
                child = helper_1.findChildren(this.dataSource[i])['values'];
                if (child && child.length) {
                    this.isHierarchicalData = true;
                    break;
                }
                else if (i === this.dataSource.length - 1) {
                    this.isHierarchicalData = false;
                }
            }
        };
        TreeMap.prototype.processHierarchicalData = function (data, dataCount) {
            var _this = this;
            var childData;
            var levelData = [];
            var newData = new Object();
            var levelIndex;
            var path = this.leafItemSettings.labelPath ? this.leafItemSettings.labelPath : this.weightValuePath;
            var currentData = new Object();
            var level;
            var key;
            newData = helper_1.findChildren(data);
            childData = newData ? newData['values'] : null;
            if (childData && childData.length > 0) {
                key = newData['key'];
                for (var i = 0; i < this.levels.length; i++) {
                    if (key === this.levels[i].groupPath) {
                        level = this.levels[i];
                        levelIndex = i;
                    }
                }
                for (var j = 0; j < childData.length; j++) {
                    childData[j]['name'] = childData[j][path];
                    childData[j]['levelOrderName'] = (levelIndex === 0 ? childData[j]['name'] :
                        data['levelOrderName'] + '_' + childData[j]['name']) + '';
                    childData[j]['groupIndex'] = ej2_base_4.isNullOrUndefined(levelIndex) ? this.levels.length : levelIndex;
                    if (levelIndex !== 0) {
                        childData[j]['parent'] = data;
                    }
                    childData[j]['groupName'] = key;
                    childData[j]['data'] = childData[j];
                    childData[j]['isDrilled'] = false;
                    childData[j]['weight'] = childData[j][this.weightValuePath];
                }
                childData.forEach(function (currentData) {
                    _this.processHierarchicalData(currentData, dataCount);
                });
            }
            if (dataCount === this.hierarchyData.length - 1) {
                var mainData_1 = this.hierarchyData[0][this.levels[0].groupPath];
                for (var k = 0; k < this.hierarchyData.length; k++) {
                    childData = helper_1.findChildren(this.hierarchyData[k])['values'];
                    if (k !== 0 && childData) {
                        childData.forEach(function (currentData) { mainData_1.push(currentData); });
                        this.hierarchyData.splice(k, 1);
                        k -= 1;
                    }
                }
                mainData_1 = this.hierarchyData[0][this.levels[0].groupPath];
                for (var l = 0; l < mainData_1.length; l++) {
                    newData[this.levels[0].groupPath] = mainData_1;
                    mainData_1[l]['parent'] = newData;
                }
            }
        };
        TreeMap.prototype.print = function (id) {
            var exportChart = new export_1.ExportUtils(this);
            exportChart.print(id);
        };
        TreeMap.prototype.export = function (type, fileName, orientation) {
            var exportMap = new export_1.ExportUtils(this);
            exportMap.export(type, fileName, orientation);
        };
        TreeMap.prototype.processFlatJsonData = function () {
            this.dataSource = this.dataSource;
            var groupPath;
            var childGroupPath;
            var orderNames = [];
            var process = false;
            for (var i = 0; i < this.levels.length + 1; i++) {
                groupPath = this.levels[i] ? this.levels[i].groupPath : this.leafItemSettings.labelPath;
                var level = new Object();
                level['level'] = i;
                level[groupPath] = [];
                this.levelsOfData.push(level);
                for (var j = 0; j < this.dataSource.length; j++) {
                    var currentData = {};
                    var childName = '';
                    if (this.dataSource[j][groupPath]) {
                        var name_1 = this.dataSource[j][groupPath];
                        if (i !== 0) {
                            for (var k = 0; k <= i; k++) {
                                var childGroupPath_1 = this.levels[k] ? this.levels[k].groupPath : groupPath;
                                childName += (this.dataSource[j][childGroupPath_1]) + ((k === i) ? '' : '_');
                            }
                        }
                        if (!(orderNames.length > 0 ? orderNames.indexOf(childName ?
                            childName : name_1) !== -1 : false)) {
                            currentData['name'] = name_1;
                            currentData['levelOrderName'] = ((childName) ? childName : name_1) + '';
                            currentData['groupIndex'] = i;
                            currentData['isDrilled'] = false;
                            currentData['groupName'] = groupPath;
                            currentData['data'] = this.dataSource[j];
                            this.levelsOfData[this.levelsOfData.length - 1][groupPath].push(currentData);
                            orderNames.push((childName) ? childName : name_1);
                        }
                    }
                }
            }
        };
        TreeMap.prototype.reOrderLevelData = function (start) {
            var currentName;
            var currentPath = this.levels[start] ? this.levels[start].groupPath : this.leafItemSettings.labelPath;
            var prevPath = this.levels[start - 1].groupPath;
            var currentData = this.levelsOfData[start][currentPath];
            var previousData = this.levelsOfData[start - 1][prevPath];
            for (var i = 0; i < currentData.length; i++) {
                currentName = currentData[i]['levelOrderName'];
                for (var j = 0; j < previousData.length; j++) {
                    previousData[j][currentPath] = ej2_base_4.isNullOrUndefined(previousData[j][currentPath]) ? [] : previousData[j][currentPath];
                    if (currentName.indexOf(previousData[j]['levelOrderName']) !== -1) {
                        if (ej2_base_4.isNullOrUndefined(currentData[i]['parent'])) {
                            currentData[i]['parent'] = previousData[j];
                        }
                        previousData[j][currentPath].push(currentData[i]);
                        break;
                    }
                }
            }
            this.findTotalWeight(this.levelsOfData[this.levelsOfData.length - 1][currentPath], 'Child');
            this.levelsOfData.splice(start, 1);
            if ((start - 1) > 0) {
                this.reOrderLevelData(start - 1);
            }
        };
        TreeMap.prototype.findTotalWeight = function (processData, type) {
            var _this = this;
            var totalWeight;
            var childData;
            var levelName;
            var start = 0;
            var split;
            var groupName;
            var groupObj = new Object();
            var _loop_1 = function (i) {
                totalWeight = 0;
                groupName = processData[i]['groupName'];
                split = processData[i]['levelOrderName'].split('_');
                this_1.dataSource.forEach(function (data) {
                    if (helper_2.isContainsData(split, processData[i]['levelOrderName'], data, _this)) {
                        totalWeight += parseFloat(data[_this.weightValuePath]);
                    }
                });
                if (type === 'Parent') {
                    groupObj[groupName] = processData;
                    processData[i]['parent'] = groupObj;
                }
                processData[i]['weight'] = totalWeight;
            };
            var this_1 = this;
            for (var i = 0; i < processData.length; i++) {
                _loop_1(i);
            }
        };
        TreeMap.prototype.unWireEVents = function () {
            ej2_base_4.EventHandler.remove(this.element, 'click', this.clickOnTreeMap);
            ej2_base_4.EventHandler.remove(this.element, ej2_base_4.Browser.touchStartEvent, this.mouseDownOnTreeMap);
            ej2_base_4.EventHandler.remove(this.element, ej2_base_4.Browser.touchMoveEvent, this.mouseMoveOnTreeMap);
            ej2_base_4.EventHandler.remove(this.element, ej2_base_4.Browser.touchEndEvent, this.mouseEndOnTreeMap);
            ej2_base_4.EventHandler.remove(this.element, 'pointerleave mouseleave', this.mouseLeaveOnTreeMap);
            window.removeEventListener('resize', this.resizeOnTreeMap);
        };
        TreeMap.prototype.wireEVents = function () {
            ej2_base_4.EventHandler.add(this.element, 'click', this.clickOnTreeMap, this);
            ej2_base_4.EventHandler.add(this.element, ej2_base_4.Browser.touchStartEvent, this.mouseDownOnTreeMap, this);
            ej2_base_4.EventHandler.add(this.element, ej2_base_4.Browser.touchMoveEvent, this.mouseMoveOnTreeMap, this);
            ej2_base_4.EventHandler.add(this.element, ej2_base_4.Browser.touchEndEvent, this.mouseEndOnTreeMap, this);
            ej2_base_4.EventHandler.add(this.element, 'pointerleave mouseleave', this.mouseLeaveOnTreeMap, this);
            window.addEventListener('resize', this.resizeOnTreeMap.bind(this));
        };
        TreeMap.prototype.setCulture = function () {
            this.intl = new ej2_base_3.Internationalization();
        };
        TreeMap.prototype.addTabIndex = function () {
            this.element.setAttribute('aria-label', this.description || 'TreeMap Element');
            this.element.setAttribute('tabindex', this.tabIndex.toString());
        };
        TreeMap.prototype.resizeOnTreeMap = function (e) {
            var _this = this;
            var args = {
                name: constants_2.resize,
                cancel: false,
                previousSize: this.availableSize,
                currentSize: new helper_1.Size(0, 0),
                treemap: this
            };
            if (this.resizeTo) {
                clearTimeout(this.resizeTo);
            }
            if (this.element.classList.contains('e-treemap')) {
                this.resizeTo = setTimeout(function () {
                    _this.unWireEVents();
                    _this.createSvg();
                    _this.refreshing = true;
                    _this.wireEVents();
                    args.currentSize = _this.availableSize;
                    _this.trigger(constants_2.resize, args);
                    _this.render();
                }, 500);
            }
        };
        TreeMap.prototype.clickOnTreeMap = function (e) {
            var targetEle = e.target;
            var targetId = targetEle.id;
            var eventArgs;
            var itemIndex;
            var clickArgs = { cancel: false, name: constants_2.click, treemap: this, mouseEvent: e };
            this.trigger(constants_2.click, clickArgs);
            if (targetId.indexOf('_Item_Index') > -1) {
                e.preventDefault();
                itemIndex = parseFloat(targetId.split('_')[6]);
                eventArgs = { cancel: false, name: constants_2.itemClick, treemap: this, item: this.layout.renderItems[itemIndex], mouseEvent: e };
                this.trigger(constants_2.itemClick, eventArgs);
            }
        };
        TreeMap.prototype.mouseDownOnTreeMap = function (e) {
            var targetEle = e.target;
            var startEvent;
            var endEvent;
            var targetId = targetEle.id;
            var totalRect;
            var index;
            var newDrillItem = new Object();
            var item;
            var process = true;
            var layoutID = this.element.id + '_TreeMap_' + this.layoutType + '_Layout';
            if (targetId.indexOf('_Item_Index') > -1 && this.enableDrillDown) {
                e.preventDefault();
                index = parseFloat(targetId.split('_')[6]);
                item = this.layout.renderItems[index];
                if (this.levels.length !== 0 && !item['isLeafItem'] && helper_1.findChildren(item)['values'] &&
                    helper_1.findChildren(item)['values'].length > 0) {
                    if (this.drilledItems.length > 0) {
                        for (var i = 0; i < this.drilledItems.length; i++) {
                            if (item['levelOrderName'] === this.drilledItems[i]['name']) {
                                if (item['groupIndex'] === 0 && item['parent'][item['groupName']] instanceof Array) {
                                    item['isDrilled'] = !(item['isDrilled']);
                                    if (!item['isDrilled']) {
                                        newDrillItem = item['parent'];
                                    }
                                    else {
                                        newDrillItem[item['groupName']] = [item];
                                    }
                                }
                                else {
                                    item['isDrilled'] = false;
                                    item['parent']['isDrilled'] = true;
                                    item = item['parent'];
                                    newDrillItem[item['groupName']] = [item];
                                }
                                this.drilledItems.splice(i, 1);
                                i -= 1;
                                break;
                            }
                            else if (i === this.drilledItems.length - 1) {
                                item['isDrilled'] = true;
                                newDrillItem[item['groupName']] = [item];
                            }
                        }
                    }
                    else {
                        item['isDrilled'] = true;
                        newDrillItem[item['groupName']] = [item];
                    }
                    startEvent = { cancel: false, name: constants_1.drillStart, treemap: this, item: newDrillItem, element: targetEle };
                    this.trigger(constants_1.drillStart, startEvent);
                    if (!startEvent.cancel) {
                        if (document.getElementById(layoutID)) {
                            document.getElementById(layoutID).remove();
                        }
                        totalRect = ej2_base_1.extend({}, this.areaRect, totalRect, true);
                        this.layout.calculateLayoutItems(newDrillItem, totalRect);
                        this.layout.renderLayoutItems(newDrillItem);
                    }
                    endEvent = { cancel: false, name: constants_1.drillEnd, treemap: this, renderItems: this.layout.renderItems };
                    this.trigger(constants_1.drillEnd, endEvent);
                    if (process) {
                        this.drilledItems.push({ name: item['levelOrderName'], data: item });
                    }
                }
            }
            this.notify(ej2_base_4.Browser.touchStartEvent, e);
        };
        TreeMap.prototype.mouseMoveOnTreeMap = function (e) {
            var targetEle = e.target;
            var targetId = targetEle.id;
            var eventArgs;
            var item;
            var moveArgs = { cancel: false, name: constants_2.mouseMove, treemap: this, mouseEvent: e };
            this.trigger(constants_2.mouseMove, moveArgs);
            var childItems;
            if (targetId.indexOf('_Item_Index') > -1) {
                item = this.layout.renderItems[parseFloat(targetId.split('_')[6])];
                childItems = helper_1.findChildren(item)['values'];
                this.element.style.cursor = (!item['isLeafItem'] && childItems && childItems.length > 0 && this.enableDrillDown) ?
                    'pointer' : 'auto';
                eventArgs = { cancel: false, name: constants_2.itemMove, treemap: this, item: item, mouseEvent: e };
                this.trigger(constants_2.itemMove, eventArgs);
            }
            this.notify(ej2_base_4.Browser.touchMoveEvent, e);
        };
        TreeMap.prototype.mouseEndOnTreeMap = function (e) {
            this.notify(ej2_base_4.Browser.touchEndEvent, e);
        };
        TreeMap.prototype.mouseLeaveOnTreeMap = function (e) {
            if (this.treeMapTooltipModule) {
                this.treeMapTooltipModule.removeTooltip();
            }
            if (this.treeMapLegendModule) {
                this.treeMapLegendModule.removeInteractivePointer();
            }
            helper_1.removeClassNames(document.getElementsByClassName('treeMapHighLight'), 'treeMapHighLight', this);
        };
        TreeMap.prototype.requiredModules = function () {
            var modules = [];
            if (this.tooltipSettings.visible) {
                modules.push({
                    member: 'treeMapTooltip',
                    args: [this]
                });
            }
            if (this.highlightSettings.enable) {
                modules.push({
                    member: 'treeMapHighlight',
                    args: [this]
                });
            }
            if (this.selectionSettings.enable) {
                modules.push({
                    member: 'treeMapSelection',
                    args: [this]
                });
            }
            if (this.legendSettings.visible) {
                modules.push({
                    member: 'treeMapLegend',
                    args: [this]
                });
            }
            return modules;
        };
        TreeMap.prototype.onPropertyChanged = function (newProp, oldProp) {
            var render = false;
            for (var _i = 0, _a = Object.keys(newProp); _i < _a.length; _i++) {
                var prop = _a[_i];
                switch (prop) {
                    case 'background':
                        this.renderBorder();
                        break;
                    case 'height':
                    case 'width':
                        render = true;
                        break;
                }
            }
            if (render) {
                this.createSvg();
                this.render();
            }
        };
        TreeMap.prototype.getModuleName = function () {
            return 'treemap';
        };
        TreeMap.prototype.destroy = function () {
            this.unWireEVents();
            _super.prototype.destroy.call(this);
        };
        TreeMap.prototype.getPersistData = function () {
            return '';
        };
        __decorate([
            ej2_base_1.Property(null)
        ], TreeMap.prototype, "width", void 0);
        __decorate([
            ej2_base_1.Property(null)
        ], TreeMap.prototype, "height", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_1.Border)
        ], TreeMap.prototype, "border", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_1.Margin)
        ], TreeMap.prototype, "margin", void 0);
        __decorate([
            ej2_base_1.Property(null)
        ], TreeMap.prototype, "background", void 0);
        __decorate([
            ej2_base_1.Property('Material')
        ], TreeMap.prototype, "theme", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_1.TitleSettings)
        ], TreeMap.prototype, "titleSettings", void 0);
        __decorate([
            ej2_base_1.Property('Squarified')
        ], TreeMap.prototype, "layoutType", void 0);
        __decorate([
            ej2_base_1.Property(null)
        ], TreeMap.prototype, "dataSource", void 0);
        __decorate([
            ej2_base_1.Property(null)
        ], TreeMap.prototype, "query", void 0);
        __decorate([
            ej2_base_1.Property(null)
        ], TreeMap.prototype, "weightValuePath", void 0);
        __decorate([
            ej2_base_1.Property('')
        ], TreeMap.prototype, "rangeColorValuePath", void 0);
        __decorate([
            ej2_base_1.Property('')
        ], TreeMap.prototype, "equalColorValuePath", void 0);
        __decorate([
            ej2_base_1.Property([])
        ], TreeMap.prototype, "palette", void 0);
        __decorate([
            ej2_base_1.Property(false)
        ], TreeMap.prototype, "enableDrillDown", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_1.InitialDrillSettings)
        ], TreeMap.prototype, "initialDrillDown", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_2.LeafItemSettings)
        ], TreeMap.prototype, "leafItemSettings", void 0);
        __decorate([
            ej2_base_2.Collection([], base_2.LevelSettings)
        ], TreeMap.prototype, "levels", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_2.HighlightSettings)
        ], TreeMap.prototype, "highlightSettings", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_2.SelectionSettings)
        ], TreeMap.prototype, "selectionSettings", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_2.TooltipSettings)
        ], TreeMap.prototype, "tooltipSettings", void 0);
        __decorate([
            ej2_base_2.Complex({}, base_1.LegendSettings)
        ], TreeMap.prototype, "legendSettings", void 0);
        __decorate([
            ej2_base_1.Property(false)
        ], TreeMap.prototype, "useGroupingSeparator", void 0);
        __decorate([
            ej2_base_1.Property(null)
        ], TreeMap.prototype, "description", void 0);
        __decorate([
            ej2_base_1.Property(1)
        ], TreeMap.prototype, "tabIndex", void 0);
        __decorate([
            ej2_base_1.Property(null)
        ], TreeMap.prototype, "format", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "load", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "beforePrint", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "loaded", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "itemRendering", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "drillStart", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "drillEnd", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "itemSelected", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "itemHighlight", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "tooltipRendering", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "itemClick", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "itemMove", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "click", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "mouseMove", void 0);
        __decorate([
            ej2_base_3.Event()
        ], TreeMap.prototype, "resize", void 0);
        TreeMap = __decorate([
            ej2_base_1.NotifyPropertyChanges
        ], TreeMap);
        return TreeMap;
    }(ej2_base_1.Component));
    exports.TreeMap = TreeMap;
});
