import { TreeMap } from '../treemap';
/**
 * Performing treemap highlight
 */
export declare class TreeMapHighlight {
    private treemap;
    private highLightId;
    constructor(treeMap: TreeMap);
    mouseMove(e: PointerEvent): boolean;
    /**
     * To bind events for highlight
     */
    private addEventListener();
    /**
     * To unbind events for highlight
     */
    private removeEventListener();
    /**
     * Get module name.
     */
    protected getModuleName(): string;
    /**
     * To destroy the hightlight.
     * @return {void}
     * @private
     */
    destroy(treeMap: TreeMap): void;
}
export declare class TreeMapSelection {
    private treemap;
    private selectionId;
    constructor(treeMap: TreeMap);
    mouseDown(e: PointerEvent): void;
    /**
     * To bind events for selection
     */
    private addEventListener();
    /**
     * To unbind events for selection
     */
    private removeEventListener();
    /**
     * Get module name.
     */
    protected getModuleName(): string;
    /**
     * To destroy the selection.
     * @return {void}
     * @private
     */
    destroy(treeMap: TreeMap): void;
}
